{*******************************************************}
{                     PHP4Delphi                        }
{               PHP - Delphi interface                  }
{                                                       }
{ Author:                                               }
{ Serhiy Perevoznyk                                     }
{ serge_perevoznyk@hotmail.com                          }
{ http://users.chello.be/ws36637                        }
{*******************************************************}
{$I PHP.INC}

{ $Id: DelphiFunctions.pas,v 5.2 2003/11/25 19:59:39 delphi32 Exp $ }

unit DelphiFunctions;

interface
uses
  Windows, SysUtils, Classes, ZendAPI, PHPAPI, Dialogs, ShellAPI, typinfo;

var
  DelphiTable : array [0..10] of zend_function_entry;

 author_functions : array[0..2] of zend_function_entry;
 author_class_entry : Tzend_class_entry;
 ce : pzend_class_entry;

 DelphiObjectMethods : array[0..2] of zend_function_entry;
 DelphiObjectEntry : TZend_class_entry;
 DelphiObject : pzend_class_entry;

procedure InitDelphiFunctions;
procedure RegisterAuthorClass(p : pointer);
procedure RegisterDelphiObjectClass(p : pointer);

implementation


procedure delphi_get_system_directory(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;

var
  Dir: array[0..MAX_PATH] of Char;
  p : pchar;
begin
  GetSystemDirectory(Dir, MAX_PATH);
  p := dir;
  ZVAL_STRING(return_value, p, true);
end;

procedure delphi_str_date(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
begin
  ZVAL_STRING(return_value, PChar(DateToStr(Date)), true);
end;


procedure delphi_date(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
begin
  ZVAL_DOUBLE(return_value, Date);
end;

procedure delphi_extract_file_dir(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
var
  Param : pzval_array;
  P : PChar;
begin
  if ( not (zend_get_parameters_ex(1, Param) = SUCCESS )) then
  begin
    zend_wrong_param_count(TSRMLS_DC);
    Exit;
  end;
  convert_to_string(param[0]^);
  p := PChar(ExtractFileDir(param[0]^.value.str.val));
  ZVAL_STRING(return_value, p, true);
  dispose_pzval_array(Param);
end;


procedure delphi_extract_file_drive(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
var
  Param : pzval_array;
  P : PChar;
begin
  if ( not (zend_get_parameters_ex(1, Param) = SUCCESS )) then
  begin
    zend_wrong_param_count(TSRMLS_DC);
    Exit;
  end;
  convert_to_string(param[0]^);
  p := PChar(ExtractFileDrive(param[0]^.value.str.val));
  ZVAL_STRING(return_value, p, true);
  dispose_pzval_array(Param);
end;


procedure delphi_extract_file_name(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
var
  Param : pzval_array;
  P : PChar;
begin
  if ( not (zend_get_parameters_ex(1, Param) = SUCCESS )) then
  begin
    zend_wrong_param_count(TSRMLS_DC);
    Exit;
  end;
  convert_to_string(param[0]^);
  p := PChar(ExtractFileName(param[0]^.value.str.val));
  ZVAL_STRING(return_value, p, true);
  dispose_pzval_array(Param);
end;


procedure delphi_extract_file_ext(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
var
  Param : pzval_array;
  P : PChar;
begin
  if ( not (zend_get_parameters_ex(1, Param) = SUCCESS )) then
  begin
    zend_wrong_param_count(TSRMLS_DC);
    Exit;
  end;
  convert_to_string(param[0]^);
  p := PChar(ExtractFileExt(param[0]^.value.str.val));
  ZVAL_STRING(return_value, p, true);
  dispose_pzval_array(Param);
end;


procedure delphi_show_message(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
var
  Param : pzval_array;
  P : PChar;
begin
  if ( not (zend_get_parameters_ex(1, Param) = SUCCESS )) then
  begin
    zend_wrong_param_count(TSRMLS_DC);
    Exit;
  end;
  convert_to_string(param[0]^);
  p := param[0]^.value.str.val;
  ShowMessage(P);
  dispose_pzval_array(Param);
end;


procedure delphi_send_email(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
begin
  ShellExecute(0, 'open', 'mailto:serge_perevoznyk@hotmail.com', nil, nil, SW_SHOWNORMAL);
end;


procedure delphi_visit_homepage(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
begin
  ShowMessage('visit http://psvlib.sourceforge.net');
end;


procedure RegisterAuthorClass(p : pointer);
begin
  author_functions[0].fname := 'send_email';
  author_functions[0].handler := @delphi_send_email;
  author_functions[1].fname := 'visit_homepage';
  author_functions[1].handler := @delphi_visit_homepage;
  INIT_CLASS_ENTRY(author_class_entry, 'php4delphi_author', @author_functions);
  ce := zend_register_internal_class(@author_class_entry, p);
end;


//Delphi objects support

procedure delphi_object_classname(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
var
 OBJ : TObject;
 data: ^ppzval;
 P : string;
begin
 new(data);
 zend_hash_find(this_ptr^.value.obj.properties, 'instance', strlen('instance') + 1, data);
 Obj := TObject(data^^^.value.lval);
 P := Obj.ClassName;
 ZVAL_STRING(return_value, PChar(p), true);
 freemem(data);
end;


procedure delphi_object_classnameis(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
var
 OBJ : TObject;
 data: ^ppzval;
 P : PChar;
 Param : pzval_array;
begin
  if ( not (zend_get_parameters_ex(1, Param) = SUCCESS )) then
  begin
    zend_wrong_param_count(TSRMLS_DC);
    Exit;
  end;
 convert_to_string(param[0]^);
 p := param[0]^.value.str.val;
 new(data);
 zend_hash_find(this_ptr^.value.obj.properties, 'instance', strlen('instance') + 1, data);
 Obj := TObject(data^^^.value.lval);
 ZVAL_BOOL(return_value,Obj.ClassNameIs(p));
 freemem(data);
end;



function delphi_set_property_handler(property_reference : Pzend_property_reference; value : pzval) : integer; cdecl;
var
 this_ptr : pzval;
 OBJ : TObject;
 data: ^ppzval;
 element : pzend_list_element;
 prop  : pzend_overloaded_element;
 p : pointer;
 propname : string;
begin
  element :=  property_reference^.elements_list^.head;
  p := @element^.data;
  prop := pzend_overloaded_element(p);
  propname := prop^.element.value.str.val;
  this_ptr := property_reference^._object;
  new(data);
  zend_hash_find(this_ptr^.value.obj.properties, 'instance', strlen('instance') + 1, data);
  Obj := TObject(data^^^.value.lval);
  SetPropValue(OBJ, propname, zval2variant(value^));
  freemem(data);
  Result := SUCCESS;
end;

function delphi_get_property_handler(property_reference : PZend_property_reference) : pzval; cdecl;
var
 this_ptr : pzval;
 OBJ : TObject;
 data: ^ppzval;
 element : pzend_list_element;
 prop  : pzend_overloaded_element;
 p : pointer;
 propname : string;
 presult : pzval;
begin
  element :=  property_reference^.elements_list^.head;
  p := @element^.data;
  prop := pzend_overloaded_element(p);
  propname := prop^.element.value.str.val;
  this_ptr := property_reference^._object;
  new(data);
  zend_hash_find(this_ptr^.value.obj.properties, 'instance', strlen('instance') + 1, data);
  Obj := TObject(data^^^.value.lval);
  new(presult);
  variant2zval(GetPropValue(OBJ, propname), presult);
  freemem(data);
  Result := presult;
end;


procedure RegisterDelphiObjectClass(p : pointer);
begin
  DelphiObjectMethods[0].fname := 'classname';
  DelphiObjectMethods[0].handler := @delphi_object_classname;
  DelphiObjectMethods[1].fname := 'classnameis';
  DelphiObjectMethods[1].handler := @delphi_object_classnameis;
  FillChar(DelphiObjectEntry, SizeOf(DelphiObjectEntry), #0);
  INIT_CLASS_ENTRY(DelphiObjectEntry, 'delphi_class' , @DelphiObjectMethods);
 // DelphiObjectEntry.handle_property_get := @delphi_get_property_handler;
  DelphiObjectEntry.handle_property_set := @delphi_set_property_handler;
  DelphiObject := zend_register_internal_class(@DelphiObjectEntry,  p);
end;

procedure delphi_get_author(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
var
 properties : array[0..3] of pchar;
begin
  properties[0] := 'name';
  properties[1] := 'last';
  properties[2] := 'height';
  properties[3] := 'email';
  _object_init_ex(return_value, ce, nil, 0, TSRMLS_DC );
  add_property_string_ex(return_value, properties[0], strlen(properties[0]) + 1, 'Serhiy', 1);
  add_property_string_ex(return_value, properties[1], strlen(properties[1]) + 1, 'Perevoznyk', 1);
  add_property_long_ex(return_value, properties[2], strlen(properties[2]) + 1, 185);
  add_property_string_ex(return_value, properties[3], strlen(properties[3]) + 1, 'serge_perevoznyk@hotmail.com', 1);
end;



procedure register_delphi_object(ht : integer; return_value : pzval; this_ptr : pzval;
      return_value_used : integer; TSRMLS_DC : pointer); cdecl;
var
 properties : array[0..0] of pchar;
 Param : pzval_array;
 Obj : TObject;
 PropList: PPropList;
 ClassTypeInfo: PTypeInfo;
 ClassTypeData: PTypeData;
 i: integer;
 S : string;
 FCount : integer;
begin
  if ( not (zend_get_parameters_ex(1, Param) = SUCCESS )) then
  begin
    zend_wrong_param_count(TSRMLS_DC);
    Exit;
  end;
  Obj := TObject(Param[0]^.value.lval);
  properties[0] := 'instance';
  _object_init_ex(return_value, DelphiObject, nil, 0, TSRMLS_DC );
  add_property_resource_ex(return_value, properties[0], strlen(properties[0]) + 1, Integer(Obj));

  ClassTypeInfo := OBJ.ClassInfo;
  ClassTypeData := GetTypeData(ClassTypeInfo);
  if ClassTypeData.PropCount <> 0 then
  begin
    FCount := GetPropList(OBJ.ClassInfo, [tkInteger, tkChar, tkFloat, tkString,
      tkWChar, tkLString, tkWString], nil);
    GetMem(PropList, SizeOf(PPropInfo) * FCount);
    try
      GetPropList(Obj.ClassInfo, [tkInteger, tkChar, tkFloat, tkString,
      tkWChar, tkLString, tkWString],  PropList);
      for i := 0 to FCount - 1 do
        begin
          S := PropList[i]^.Name;
          case proplist[i]^.PropType^.Kind of
           tkInteger, tkChar, tkWChar, tkClass: add_property_long_ex(return_value, PChar(S), Length(s) +1, GetOrdProp(OBJ, S));
           tkString, tkLString, tkWString: add_property_string_ex(return_value, PChar(S), length(S) + 1, PChar(GetStrProp(OBJ, S)), 1 );
           tkFloat : add_property_double_ex(return_value, PChar(s), Length(S) +1, GetFloatProp(Obj,S));
          end;
        end;
    finally
      FreeMem(PropList, SizeOf(PPropInfo) * ClassTypeData.PropCount);
    end;
  end;

   
end;

procedure InitDelphiFunctions;
begin
  PHP_FUNCTION(DelphiTable[0], 'delphi_date', @delphi_date);
  PHP_FUNCTION(DelphiTable[1], 'delphi_extract_file_dir', @delphi_extract_file_dir);
  PHP_FUNCTION(DelphiTable[2], 'delphi_extract_file_drive', @delphi_extract_file_drive);
  PHP_FUNCTION(DelphiTable[3], 'delphi_extract_file_name', @delphi_extract_file_name);

  DelphiTable[4].fname := 'delphi_extract_file_ext';
  DelphiTable[4].handler := @delphi_extract_file_ext;
  DelphiTable[4].func_arg_types := nil;

  DelphiTable[5].fname := 'delphi_show_message';
  DelphiTable[5].handler := @delphi_show_message;
  DelphiTable[5].func_arg_types := nil;

  DelphiTable[6].fname := 'delphi_get_author';
  DelphiTable[6].handler := @delphi_get_author;
  DelphiTable[6].func_arg_types := nil;

  DelphiTable[7].fname := 'delphi_str_date';
  DelphiTable[7].handler := @delphi_str_date;
  DelphiTable[7].func_arg_types := nil;

  PHP_FUNCTION(DelphiTable[8], 'delphi_get_system_directory', @delphi_get_system_directory);

  PHP_FUNCTION(DelphiTable[9], 'register_delphi_object', @register_delphi_object);
end;

end.